#include <stdio.h>

/* Questa funzione ordina l'array dato in input utilizzando l'algoritmo di selection sort.
   Parametri:
   int array[]: array da analizzare
   int lunghezza: lunghezza array 
*/
void selectionSort(int array[], int lunghezza);

/* Questa funzione calcola la mediana nell'array ORDINATO dato in input.
   Ai fini di questo esercizio la mediana e' definita solo su array di dimensione dispari
   Parametri:
   int array[]: array da analizzare
   int lunghezza: lunghezza array 
*/
int mediana(int array[], int lunghezza);

#define LUNGHEZZA 5

int main()
{
	int array[LUNGHEZZA];
	
	/*Chiedo all'utente LUNGHEZZA numeri interi*/
	int i;
	for (i=0;i<LUNGHEZZA;i++)
	{
		printf("Inserisci un numero intero: ");
		scanf("%d", &array[i]);		
	}
	
	/*Ordino l'array*/	
	selectionSort(array,LUNGHEZZA);
	
	/*Verifico che i numeri inseriti siano tutti diversi*/
	for (i=1;i<LUNGHEZZA;i++)
	{
		if (array[i-1]==array[i])
		{
			printf("Il numero %d e' stato inserito piu' di una volta",array[i]);
			return 1;
		}
	}
	
	/*Calcolo la mediana*/
	printf("Mediana: %d", mediana(array,LUNGHEZZA));	
	
	return 0;
}

/* Questa funzione ordina l'array dato in input utilizzando l'algoritmo di selection sort.
   Parametri:
   int array[]: array da analizzare
   int lunghezza: lunghezza array 
*/
void selectionSort(int array[], int lunghezza)
{
	int i, j, jmin, aux;
	for (i=0; i<lunghezza-1; i++) 
	{
		/* trova il pi piccolo elemento da i a n-1 */
		jmin = i;
		for (j=i+1; j<lunghezza; j++)
		{
			if (array[j] < array[jmin])        
			{
				jmin = j;
			}
        }
		
		/* scambia gli elementi in posizione i e jmin */
		aux = array[jmin];
		array[jmin] = array[i];
		array[i] = aux;
	}
}

/* Questa funzione calcola la mediana nell'array ORDINATO dato in input.
   Ai fini di questo esercizio la mediana e' definita solo su array di dimensione dispari
   Parametri:
   int array[]: array da analizzare
   int lunghezza: lunghezza array 
*/
int mediana(int array[], int lunghezza)
{
	if (lunghezza%2==0)
		return -1;
	return array[(lunghezza-1)/2];
}