#include <stdio.h>
#include <math.h>

/* Questa funzione gestisce la voce di menu mcm*/
void mcmMenu();
/*Questa funzione calcola l'mcd fra due numeri interi (minore deve essere minore di maggiore)*/
int mcd(int minore, int maggiore);
/* Questa funzione calcola l'mcm fra due numeri interi (minore deve essere minore di maggiore)*/
int mcm(int minore, int maggiore);

/* Questa funzione gestisce la voce di menu numeri primi*/
void numeriPrimiMenu();
/* Questa funzione determina se un numero intero positivo e' primo*/
int numeroPrimo(unsigned int numero);


	
/* Questa funzione gestisce la voce di menu scomposizione in fattori primi*/
void scomposizioneInFattoriPrimiMenu();

int main()
{
	char scelta;
	
	while (1)
	{
		/*Stampo il menu*/	
		printf("(a) MCM\n(b) Numeri Primi\n(c) Scomposizione in Fattori\n(x) Esci\nCosa vuoi fare [abcx]?");
		scanf(" %c",&scelta);
		
		switch (scelta)
		{
			case 'a':
				mcmMenu();
				break;
			case 'b':
				numeriPrimiMenu();
				break;
			case 'c':
				scomposizioneInFattoriPrimiMenu();
				break;
			case 'x':
				return 0;
			default:
				printf("Scelta errata, riprova.\n");
		}
		
	
	}
	return 0;
}

/* Questa funzione gestisce la voce di menu mcm*/
void mcmMenu()
{
	int a,b;
		
	/*Richiedo due numeri all'utente*/	
	printf("Inserisci due numeri interi: ");
	scanf("%d %d", &a,&b);
	
	/*Stampo l'MCM*/
	if (a>b)
		printf("L'MCM fra %d e %d e' %d\n",a,b,mcm(b,a));
	else
		printf("L'MCM fra %d e %d e' %d\n",a,b,mcm(a,b));	
}

/*Questa funzione calcola l'mcm fra due numeri interi (minore deve essere minore di maggiore)*/
int mcm(int minore, int maggiore)
{
	return (minore*maggiore)/mcd(minore,maggiore);	
}

/*Questa funzione calcola l'mcd fra due numeri interi (minore deve essere minore di maggiore)*/
int mcd(int minore, int maggiore)
{
    if (minore == 0)
      return maggiore;
    else
	{
		int mcd = minore;
		while (mcd>0)
		{
			if (maggiore%mcd==0 && minore%mcd==0)
				return mcd;
			mcd--;
		}		
		return 1;
	}        
}

/* Questa funzione gestisce la voce di menu numeri primi*/
void numeriPrimiMenu()
{
	int max;
		
	/*Richiedo un numero all'utente*/	
	printf("Inserisci il numero massimo (>1): ");
	scanf("%u", &max);
	
	printf("Numeri primi fra 1 e %u: ",max);
	unsigned int i;
	for (i=1;i<=max;++i)
	{
		if (numeroPrimo(i))
			printf("%u ",i);
	}
	printf("\n");
}

/* Questa funzione determina se un numero intero positivo e' primo*/
int numeroPrimo(unsigned int numero)
{
	if (numero==1)
		return 1;
	unsigned int i;
	for(i=2;i<numero;i++)
	{
		if(numero%i == 0)
			return 0;	
	}
	return 1;	
}

/* Questa funzione gestisce la voce di menu scomposizione in fattori primi*/
void scomposizioneInFattoriPrimiMenu()
{
	unsigned int numero;
		
	/*Richiedo un numero all'utente*/	
	printf("Inserisci il numero intero positivo da scomporre: ");
	scanf("%u", &numero);
	
	printf("I fattori di %d sono: ",numero);
	unsigned int i;
	unsigned int max=sqrt(numero);
	for (i=2;i<=max;++i)
	{
		if (numeroPrimo(i) && numero % i ==0)
		{
			printf("%d ",i);
			numero=numero/i;
			i--;/*Testo nuovamente lo stesso numero*/
		}
	}
	printf("\n");
}

